# Starting code for Lab 10

import os, sys, random
# if needed, uncomment and edit one of the lines below:
# Mac:
# os.chdir("/Users/your_username/Desktop/lab10_files")
# Windows:
# os.chdir("C:\\Documents and Settings\\your_username\\Desktop\\lab10_files")

# don't change this line
sys.path.append(os.getcwd())

# import the Picture constructor from the pix module
from pix import Picture

# create some Picture objects
slc1 = Picture("slc1.gif")
slc2 = Picture("slc2.gif")
#santa = Picture("santa.gif")

# sets all pixels to red
def red(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        for x in range(0, width):
            rgbValues = [255, 0, 0]
            img.setPixel(x, y, rgbValues)
        if y % 10 == 0:  # update image every 10 rows
            img.update()

# converts an image to grayscale
def gray(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        for x in range(0, width):
            r, g, b = img.getPixel(x, y)
            avg = (r + g + b) // 3
            rgbValues = [avg, avg, avg]
            img.setPixel(x, y, rgbValues)
        if y % 10 == 0:
            img.update()

# converts an image to a "charcoal drawing"
def charcoal(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        for x in range(0, width):
            r, g, b = img.getPixel(x, y)
            avg = (r + g + b) // 3
            if avg < 128:
                img.setPixel(x, y, [0,0,0])  # black
            else:
                img.setPixel(x, y, [255,255,255])  # white
        if y % 10 == 0:
            img.update()

# converts an image to its "photographic negative"
def invert(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        for x in range(0, width):
            r, g, b = img.getPixel(x, y)
            newR = 255 - r
            newG = 255 - g
            newB = 255 - b
            rgbValues = [newR, newG, newB]
            img.setPixel(x, y, rgbValues)
        if y % 10 == 0:
            img.update()

# converts an image to sepia tone
def sepia(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        for x in range(0, width):
            r, g, b = img.getPixel(x, y)
            newR = clip(int(r*0.393 + g*0.769 + b*0.189))
            newG = clip(int(r*0.349 + g*0.686 + b*0.168))
            newB = clip(int(r*0.272 + g*0.534 + b*0.131))
            rgbValues = [newR, newG, newB]
            img.setPixel(x, y, rgbValues)
        if y % 10 == 0:
            img.update()

# keeps values within the range 0-255
def clip(n):
    if n < 0:
        return 0
    elif n > 255:
        return 255
    else:
        return n

# copies the left half of the image to the right half
def copyLeft(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        rightX = width // 2
        for x in range(0, width // 2):
            rgbValues = img.getPixel(x, y)
            img.setPixel(rightX, y, rgbValues)
            rightX = rightX + 1
        if y % 10 == 0:
            img.update()

# makes the right half of the image be a reflection of the left half
def reflectLeft(img):
    width = img.getWidth()
    height = img.getHeight()
    for y in range(0, height):
        oppositeX = width
        for x in range(0, width // 2):
            rgbValues = img.getPixel(x, y)
            img.setPixel(oppositeX, y, rgbValues)
            oppositeX = oppositeX - 1
        if y % 10 == 0:
            img.update()
